

static RooRepo _RooRepo ;

public class RooRepo : Object 
{
 
 	

	public string  id; // not really important that they are numbers..
	public string project_id;
	public string description;
	public string shortname;
	
	
	static RooRepo init()
	{
		if (_RooRepo == null) {
			_RooRepo = new RooRepo();
			RooRepo.load();
		}
		return _RooRepo;
	}
	
	static Gee.ArrayList<RooRepo> _repos; // only available for singletonn.		
	public static  Gee.ArrayList<RooRepo> repos() {
		RooRepo.init();
		return RooRepo._repos;
	}
	
	static RooRepo add(Json.Object t)
	{
		var add = new RooRepo();
		add.id = t.get_string_member("id");
		add.shortname = t.get_string_member("shortname");
		add.description = t.get_string_member("description");		
		add.project_id = t.get_string_member("project_id");						
		RooRepo._repos.add(add);
		GLib.debug("ADD project  %s : %s : %s", add.id, add.shortname, add.project_id);
		return add;
	}
	static void load() // only called from above
	{

		RooRepo._repos = new Gee.ArrayList<RooRepo>();
	 
    		
		var table = new GLib.HashTable<string, string>(str_hash, str_equal);
	 

		table.insert("limit","200");
		table.insert("sort","shortname");
		table.insert("dir","ASC");

		var params = Soup.Form.encode_hash(table);
		
		var url = "%s/%s?%s" . printf(roourl, "mtrack_repos", params);
		
		GLib.debug("request %s", url);
		
		var session = new Soup.Session ();
		session.timeout = 0;
		var message = new Soup.Message ("GET", url);
		
		
		RooTicket.setAuth(message);
		
		session.send_message (message);
		
		var data = (string) message.response_body.flatten().data;
		//GLib.debug("got %s", data);
		try {
			var parser = new Json.Parser ();
			parser.load_from_data (data, -1);

			var response = parser.get_root().get_object();
			var status = response.get_boolean_member("success");
		
			if(!status){
				GLib.error(response.get_string_member("errorMsg"));
				return;
			}
			var rd = response.get_array_member ("data");
			
			// got a valid result...
 
			for(var i = 0; i < rd.get_length(); i++) {
				RooRepo.add(rd.get_object_element(i));
			}
			 
		
		} catch (Error e) {
			GLib.error(e.message);
			return;
		}
		
	}



}
